#include "global.h"	 	/*   PROGRAMMA PER LA VALUTAZIONE DEL CSP  */ 
#include "calcolatempo.c"	/*  Fabio Ghidini - trilok@geocities. com  */
#include "calcolachecks.c"      /*  Paolo Cristini - paolo_cri@yahoo.com   */ 
#include "percentualechecks.c"  /* Mandateci i vostri commenti se lo usate!*/
#include "percentualetempo.c"

main( argc, argv )
    int     argc;
    char    *argv[];

   {  
    int         n, k, p_orig, q_orig, tests, found, consistent;
    int         naus, kaus, variab, nnaus, kkaus, tot, n_tests;
    NETWORK     C;
    SOLUTION    solution;
    double      p, q, tempo;
    FILE        *fGeneral, *fAnalisi;
    long        aus, cBT, cBJ, cCBJ, cFC, cBM;
    float       cTOTBT, cTOTBJ, cTOTCBJ, cTOTFC, cTOTBM;
    float       cATOTBT, cATOTBJ, cATOTCBJ, cATOTFC, cATOTBM; 
    double      tBT, tBJ, tCBJ, tFC, tBM;
    float       tTOTBT, tTOTBJ, tTOTCBJ, tTOTFC, tTOTBM;   
    float       tATOTBT, tATOTBJ, tATOTCBJ, tATOTFC, tATOTBM; 


    printf("\n\n\nPROGRAMMA PER LA VALUTAZIONE DEL BACKTRACKING NEL CSP.\n\n");
    printf("Inserire il numero MASSIMO di variabili: ");
    scanf("%d",&variab);       
    n = variab; 
    printf("Inserire il numero MASSIMO di valori per ogni dominio: ");
    scanf("%d",&variab);    
    k = variab;
    printf("Inserire il numero MINIMO di variabili: ");
    scanf("%d",&variab);
    naus = variab;
    printf("Inserire il numero MINIMO di valori per ogni dominio: ");
    scanf("%d",&variab);    
    kaus = variab;
    printf("Inserire il numero di test da effettuare: ");
    scanf("%d",&n_tests);    
    srandom( 0 );
    tot = 0; 
    fGeneral = fopen("Dati.txt", "w");
    fAnalisi = fopen("Analisi.txt", "w");

for(nnaus = naus; nnaus <= n; nnaus += 1 )
for(kkaus = kaus; kkaus <= k; kkaus += 1)
   {
    tTOTBT = 0;
    tTOTBJ = 0;
    tTOTCBJ = 0;
    tTOTFC = 0;
    tTOTBM = 0;
    tATOTBT = 0;
    tATOTBJ = 0;
    tATOTCBJ = 0;
    tATOTFC = 0;
    tATOTBM = 0;
    cTOTBT = 0;
    cTOTBJ = 0;
    cTOTCBJ = 0;
    cTOTFC = 0;
    cTOTBM = 0;
    cATOTBT = 0;
    cATOTBJ = 0;
    cATOTCBJ = 0;
    cATOTFC = 0;
    cATOTBM = 0;
    aus = 0;   
    for( p_orig = 10; p_orig <= 100; p_orig += 2 )
    for( q_orig = 10; q_orig <= 100; q_orig += 2 ) {
    for( tests = 1; tests <= n_tests; tests++ ) {
          
           aus += 1;
           printf("P:%d  B:%d  CSP:%d\n",
                  nnaus, kkaus, aus);  
           fprintf(fGeneral, "P=%d B=%d CSP=%d TEST=%d\n",
                   nnaus, kkaus, aus, tests);                   
           fprintf(fGeneral, "1 Sol\n");
           
                  generate_R( C, nnaus, kkaus, p_orig, q_orig );   
                  tot++;

                  start_timers(); 
                  solve( BT, C, n, k, solution, 1, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BT\tC:%d\tT:%0.10f\n",
                  checks, tempo);
                  cBT = checks;
                  tBT = tempo;

                  start_timers(); 
                  solve( BJ, C, n, k, solution, 1, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BJ\tC:%d\tT:%0.10f\n",
                  checks, tempo); 
                  cBJ = checks;
                  tBJ = tempo;
                   
                  start_timers(); 
                  solve( CBJ, C, n, k, solution, 1, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "CBJ\tC:%d\tT:%0.10f\n",
                          checks, tempo);  
                  cCBJ = checks;
                  tCBJ = tempo;

                  start_timers(); 
                  solve( FC, C, n, k, solution, 1, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "FC\tC:%d\tT:%0.10f\n",
                          checks, tempo);   
                  cFC = checks;
                  tFC = tempo;
                             
                  start_timers(); 
                  solve( BM, C, n, k, solution, 1, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BM\tC:%d\tT:%0.10f\n",
                           checks, tempo);  
                  cBM = checks;
                  tBM = tempo;
   

                  calcolatempo(tBT, tBJ, tCBJ, tFC, tBM, &tTOTBT, &tTOTBJ,
                                &tTOTCBJ, &tTOTFC, &tTOTBM); 
                  calcolachecks(cBT, cBJ, cCBJ, cFC, cBM, &cTOTBT, &cTOTBJ,
                                &cTOTCBJ, &cTOTFC, &cTOTBM); 

          fprintf(fGeneral, "All Sol\n");
                  start_timers(); 
                  solve( BT, C, n, k, solution, 2, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BT\tC:%d\tT:%0.10f\n",
                   checks, tempo);
                  cBT = checks;
                  tBT = tempo;

                  start_timers(); 
                  solve( BJ, C, n, k, solution, 2, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BJ\tC:%d\tT:%0.10f\n",
                          checks, tempo);  
                  cBJ = checks;
                  tBJ = tempo;
               
                  start_timers(); 
                  solve( CBJ, C, n, k, solution, 2, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "CBJ\tC:%d\tT:%0.10f\n",
                         checks, tempo);  
                  cCBJ = checks;
                  tCBJ = tempo;


                  start_timers(); 
                  solve( FC, C, n, k, solution, 2, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "FC\tC:%d\tT:%0.10f\n",
                           checks, tempo);   
                  cFC = checks;
                  tFC = tempo;
                             
                  start_timers(); 
                  solve( BM, C, n, k, solution, 2, &found);
                  tempo = elapsed_time(REAL);
          fprintf(fGeneral, "BM\tC:%d\tT:%0.10f\n\n",
                          checks, tempo);  
                  cBM = checks;
                  tBM = tempo;

                 calcolatempo(tBT, tBJ, tCBJ, tFC, tBM, &tATOTBT, &tATOTBJ,
                                &tATOTCBJ, &tATOTFC, &tATOTBM); 
                 calcolachecks(cBT, cBJ, cCBJ, cFC, cBM, &cATOTBT, &cATOTBJ,
                                &cATOTCBJ, &cATOTFC, &cATOTBM); 
                 

           }
        }    
fprintf(fAnalisi, "\nNUMERO VARIABILI:%d   VALORI IN OGNI DOMINIO:%d\n\n",nnaus,kkaus);
fprintf(fAnalisi, "1 SOLUZIONE\n");
percentualetempo(&tTOTBT, &tTOTBJ,&tTOTCBJ,&tTOTFC,&tTOTBM); 
fprintf(fAnalisi,"VELOCITA':\nBT=%0.2f%\nBJ=%0.2f%\nCBJ=%0.2f%\nFC=%0.2f%\nBM=%0.2f%\n",
        tTOTBT,tTOTBJ, tTOTCBJ, tTOTFC, tTOTBM);

percentualechecks(&cTOTBT, &cTOTBJ,&cTOTCBJ, &cTOTFC, &cTOTBM);
fprintf(fAnalisi,"CHECKS:\nBT=%0.2f%\nBJ=%0.2f%\nCBJ=%0.2f%\nFC=%0.2f%\nBM=%0.2f%\n",
              cTOTBT,cTOTBJ,cTOTCBJ, cTOTFC, cTOTBM);  

fprintf(fAnalisi, "\nTUTTE LE SOLUZIONI\n"); 
percentualetempo(&tATOTBT, &tATOTBJ,&tATOTCBJ,&tATOTFC,&tATOTBM); 
fprintf(fAnalisi,"VELOCITA':\nBT=%0.2f%\nBJ=%0.2f%\nCBJ=%0.2f%\nFC=%0.2f%\nBM=%0.2f%\n",
        tATOTBT, tATOTBJ,tATOTCBJ, tATOTFC, tATOTBM);

percentualechecks(&cATOTBT, &cATOTBJ,&cATOTCBJ,&cATOTFC,&cATOTBM); 
fprintf(fAnalisi,"CHECKS:\nBT=%0.2f%\nBJ=%0.2f%\nCBJ=%0.2f%\nFC=%0.2f%\nBM=%0.2f%\n\n\n",
                    cATOTBT, cATOTBJ, cATOTCBJ, cATOTFC, cATOTBM);

}
fclose(fGeneral);
fclose(fAnalisi);
printf("\nSONO STATI GENERATI E RISOLTI %d CSP\n", tot);
printf("HAVE A NICE DAY WITH BACKTRACKING!\n\n\n"); 
}



